<?php
//## Flickr API control lib #####################################################################
require_once "lib/phpFlickr.php";
global $flickr_api_key;
$flickr_api_key = "f0b0e34cf04a234fb3bae61890f298cc"; //It's key for plugin. It does not change.
//###############################################################################################

function showFlickrPhotosSidebar($parameter) {
	global $configVal, $flickr_api_key;
	if (isset($parameter['preview'])) {
		// preview mode
		$retval = "Shows my flickr photos from sidebar.";
		return $retval;
	}
	requireComponent('Textcube.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	
	$f = new phpFlickr($flickr_api_key);
	$nickName	= isset($data['nickname']) ? $data['nickname'] : "";
	$linkStyle	= isset($data['linkStyle']) ? $data['linkStyle'] : "flickr";
	$sideSize	= isset($data['sideSize']) ? $data['sideSize'] : "75";
	$sideLength	= isset($data['sideLength']) ? $data['sideLength'] : "4";
	$sideLoad	= isset($data['sideLoad']) ? $data['sideLoad'] : "latest";
	if (!empty($nickName)) {
		$person = $f->people_findByUsername($nickName);
		$photos_url = $f->urls_getUserPhotos($person['id']);
		ob_start();
		?>
		<div id="flickrSidebar">
			<h3><a href='<?php echo $photos_url;?>' target='_blank'>Flickr: <?php echo $nickName;?> Photos</a></h3>
			<div id="flickr_badge_sidebar"><script type="text/javascript" src="http://www.flickr.com/badge_code_v2.gne?count=<?php echo $sideLength;?>&amp;display=<?php echo $sideLoad;?>&amp;size=s&amp;layout=x&amp;source=user&amp;user=<?php echo $person['id'];?>"></script></div>
			<script type="text/javascript">
			  //<![CDATA[
			  var aels = $E('#flickr_badge_sidebar a');
			  var iels = $E('#flickr_badge_sidebar img');
			  for (var i = 0; i < aels.length; i++) {
				aels[i].setAttribute('target', '_blank');
				<?php if($linkStyle == 'lightbox'){ ?>
					aels[i].setAttribute('rel', 'lightbox');
					aels[i].setAttribute('href', iels[i].getAttribute('src').replace('_s', ''));
				<?php } ?>
			  }
			  //]]>
			</script>
		</div>
		<?php
		$scriptTag = ob_get_contents();
		ob_end_clean();
		$target = $scriptTag;
	}
	return $target;
}

function showFlickrPhotosCover($parameter) {
	global $configVal, $flickr_api_key;
	if (isset($parameter['preview'])) {
		// preview mode
		$retval = "Shows my flickr photos from cover.";
		return $retval;
	}
	requireComponent('Textcube.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	
	$f = new phpFlickr($flickr_api_key);
	$nickName	= isset($data['nickname']) ? $data['nickname'] : "";
	$linkStyle	= isset($data['linkStyle']) ? $data['linkStyle'] : "flickr";
	$coverSize	= isset($data['coverSize']) ? $data['coverSize'] : "75";
	$coverLength= isset($data['coverLength']) ? $data['coverLength'] : "6";
	$coverLoad	= isset($data['coverLoad']) ? $data['coverLoad'] : "latest";
	if (!empty($nickName)) {
		$person = $f->people_findByUsername($nickName);
		$photos_url = $f->urls_getUserPhotos($person['id']);
		ob_start();
		?>
		<div id="flickrCover">
			<h3><a href='<?php echo $photos_url;?>' target='_blank'>Flickr: <?php echo $nickName;?> Photos</a></h3>
			<div id="flickr_badge_cover"><script type="text/javascript" src="http://www.flickr.com/badge_code_v2.gne?count=<?php echo $coverLength;?>&amp;display=<?php echo $coverLoad;?>&amp;size=s&amp;layout=x&amp;source=user&amp;user=<?php echo $person['id'];?>"></script></div>
			<script type="text/javascript">
			  //<![CDATA[
			  var aels = $E('#flickr_badge_cover a');
			  var iels = $E('#flickr_badge_cover img');
			  for (var i = 0; i < aels.length; i++) {
				aels[i].setAttribute('target', '_blank');
				<?php if($linkStyle == 'lightbox'){ ?>
					aels[i].setAttribute('rel', 'lightbox');
					aels[i].setAttribute('href', iels[i].getAttribute('src').replace('_s', ''));
				<?php } ?>
			  }
			  //]]>
			</script>
		</div>
		<?php
		$scriptTag = ob_get_contents();
		ob_end_clean();
		$target = $scriptTag;
	}
	return $target;
}

function showFlickrPhotosStyle($target){
	global $blogURL, $pluginURL;
	$style  = "<link rel=\"stylesheet\" type=\"text/css\" href=\"{$blogURL}/plugin/flickrPhotosStyle\" />".CRLF;
	$style .= "<script type=\"text/javascript\" src=\"{$pluginURL}/lib/selector.js\"></script>".CRLF;
	$target .= $style;
	return $target;
}

function getFlickrPhotosStyle($target){
	global $configVal;
	requireComponent('Textcube.Function.misc');
	$data = misc::fetchConfigVal($configVal);

	$sideSize	= isset($data['sideSize']) ? $data['sideSize'] : "75";
	$sideMargin = isset($data['sideMargin']) ? $data['sideMargin'] : "0px 0px 0px 0px";
	$sideImageMargin = isset($data['sideImageMargin']) ? $data['sideImageMargin'] : "1px 1px 1px 1px";
	$sideImageBorder = isset($data['sideImageBorder']) ? $data['sideImageBorder'] : "1px solid #000000";

	$coverSize	= isset($data['coverSize']) ? $data['coverSize'] : "75";
	$coverMargin = isset($data['coverMargin']) ? $data['coverMargin'] : "0px 0px 0px 0px";
	$coverImageMargin = isset($data['coverImageMargin']) ? $data['coverImageMargin'] : "1px 1px 1px 1px";
	$coverImageBorder = isset($data['coverImageBorder']) ? $data['coverImageBorder'] : "1px solid #000000";

	header('Content-type: text/css; charset=utf-8');
	echo '
		#flickrSidebar {margin:'.$sideMargin.';}
		#flickrSidebar a, #flickrSidebar a:hover {text-decoration:none; background:none;}
		#flickrSidebar .flickr_badge_image{ display:inline; margin:0; padding:0; }
		#flickrSidebar .flickr_badge_image img{ border:'.$sideImageBorder.'; margin:'.$sideImageMargin.'; padding:0; width:'.$sideSize.'px; height:'.$sideSize.'px;}

		#flickrCover {margin:'.$coverMargin.';}
		#flickrCover a, #flickrCover a:hover {text-decoration:none; background:none;}
		#flickrCover .flickr_badge_image{ display:inline; margin:0; padding:0; }
		#flickrCover .flickr_badge_image img{ border:'.$coverImageBorder.'; margin:'.$coverImageMargin.'; padding:0; width:'.$coverSize.'px; height:'.$coverSize.'px;}

	';
	flush();
}

function showFlickrPhotos($target){
	global $blogURL, $pluginURL;
	if (doesHaveOwnership()){
		ob_start();
		?>
		<script type="text/javascript">
			var obj = '', oldHTML = '', newHTML = '';	
			newHTML  = '<div id="FlickrPhotosBar">';
			newHTML += '<div style="margin-top:10px;clear:both;"><b>&bull; Flickr Photos</b></div>';
			newHTML += '<table border="0" cellpadding="0" cellspacing="0" width="100%"><tr><td width="91">';
			newHTML += '<div style="border:1px solid;border-right:0px solid;height:91px;margin-top:5px;background-color:#ffffff;">';
			newHTML += '	<select id="person" style="margin:4px 0px 3px 4px;width:40px;font-size:8pt;" title="Person mode"><option value="my" selected>My</option><option value="all">All</option></select>';
			newHTML += '	<select id="length" style="margin:4px 0px 3px 0px;width:40px;font-size:8pt;" title="List length"><option value="10" selected>10</option><option value="20">20</option><option value="30">30</option><option value="40">40</option><option value="50">50</option></select><br/>';
			newHTML += '	<input type="text" id="search" onkeypress="if (event.keyCode == 13) { actionFlickr(1); return false; }" style="margin:0px 0px 3px 4px;width:79px;font-size:9pt;" /><br/>';
			newHTML += '	<div style="margin:0px 0px 4px 4px;"><img src="<?php echo $pluginURL;?>/images/search.gif" onclick="actionFlickr(1); return false;" style="border:none;cursor:pointer;" /></div>';
			newHTML += '	<div style="margin-left:4px;"><img src="<?php echo $pluginURL;?>/images/refresh.gif" onclick="actionFlickr(0); return false;" style="border:none;cursor:pointer;" /></div>';
			newHTML += '</div>';
			newHTML += '</td><td>';
			newHTML += '<div style="border:1px solid;height:91px;margin-top:5px;line-height:normal;background-color:#ffffff;">';
			newHTML += '<iframe name="flickrview" id="flickrview" src="<?php echo $blogURL;?>/plugin/flickrPhotos" scrolling="no" style="width:100%; height:91px;margin:0;padding:0;border:none;"/>';
			newHTML += '</div>';
			newHTML += '</td></tr></table></div>';
			setTimeout("FlickrInnerHTML()", 3000);

			function FlickrInnerHTML(){
				obj = document.getElementById("toolbox-container");
				oldHTML  = obj.innerHTML;
				obj.innerHTML = oldHTML + newHTML;
			}

			function actionFlickr(flag){
				var person = document.getElementById("person");
				var length = document.getElementById("length");
				var search = document.getElementById("search");
				var flickrQueryString = "?person=" + encodeURIComponent(person.value) + "&length=" + encodeURIComponent(length.value) + "&search=" + encodeURIComponent(search.value);
				var srcTarget = document.getElementById("flickrview");
				if(flag){
					srcTarget.src = "<?php echo $blogURL;?>/plugin/flickrPhotos" + flickrQueryString;
				}else{
					parent.frames['flickrview'].location.reload();
				}
			}
		</script>
		<?php
		$script = ob_get_contents();
		ob_end_clean();
	}
	return $target.$script;
}

function getFlickrPhotos($target){
	global $pluginURL, $configVal, $flickr_api_key;
	requireComponent('Textcube.Function.misc');
	$data = misc::fetchConfigVal($configVal);

	$nickName	= isset($data['nickname']) ? $data['nickname'] : "";
	$imageAlign	= isset($data['imageAlign']) ? $data['imageAlign'] : "center";
	$linkStyle	= isset($data['linkStyle']) ? $data['linkStyle'] : "flickr";
	$personMode = isset($_GET['person']) ? $_GET['person'] : "my";
	$nickName	= ($personMode == "my") ? (!empty($nickName) ? $nickName : "") : "";
	$listLength = isset($_GET['length']) ? $_GET['length'] : 10;
	$searchKey	= (isset($_GET['search']) && !empty($_GET['search'])) ? $_GET['search'] : "";

	$f = new phpFlickr($flickr_api_key);
	if (doesHaveOwnership()){
		?>
		<html>
		<head>
		<style type="text/css">a{margin-right:1px;}</style>
		<script type="text/javascript">
			function insertPhoto(_link, _src_m, _src_l, _title, _style){
				var linkTag_A = '', linkTag_B = '', imgTag = '', imageAlign_A = '', imageAlign_B = '';
				imageAlign_A = '<div style="text-align: <?php echo $imageAlign?>;">';
				imageAlign_B = '</div>';
				if(_style == "flickr" && _src_l == ""){
					linkTag_A = '<a href="' + _link + '" title="' + _title + '" target="_blank">'; 
					linkTag_B = '</a>';
				}else{
					linkTag_A = '<a href="' + _src_l + '" title="' + _title + '" rel="lightbox" target="_blank">'; 
					linkTag_B = '</a><br />';
					linkTag_B += '<a href="' + _link + '" title="' + _title + '" target="_blank">Original Flickr Photo Link.</a>';
				}
				imgTag	= '<img src="' + _src_m + '" border="0" />';

				var isWYSIWYG = false;

				try{
					if(parent.editor.editMode == 'WYSIWYG'){
						isWYSIWYG = true;
					}
				}
				catch(e){ }
				if(isWYSIWYG) {
					parent.editor.command('Raw', imageAlign_A + linkTag_A + imgTag, linkTag_B + imageAlign_B);
				}else{
					parent.insertTag(parent.editor.textarea, imageAlign_A + linkTag_A + imgTag, linkTag_B + imageAlign_B);
				}
			}
		</script>
		</head>
		<body style="margin:0;padding:0;border:none;background-color:#ffffff;">
		<div id="photosBody" style="white-space:nowrap;height:91px;width:100%;overflow-x:auto;overflow-y:hidden;">
		<?php
		if ($personMode == "my" && !empty($nickName) && empty($searchKey)) {
			$person = $f->people_findByUsername($nickName);
			$photos_url = $f->urls_getUserPhotos($person['id']);
			$photos = $f->people_getPublicPhotos($person['id'], NULL, $listLength);

			foreach ((array)$photos['photo'] as $photo) {
				$imgLink = $photos_url.$photo['id'];
				$imgSrc = $f->buildPhotoURL($photo, "Square");
				$imgPostSrc = str_replace("_s.", ".", $imgSrc);
				$imgLinkSrc = ($linkStyle == "lightbox")? $f->buildPhotoURL($photo, "original") : "";
				echo "<img src='" . $imgSrc . "' border='0' alt='{$photo['title']}' title='{$photo['title']}' onclick=\"insertPhoto('{$imgLink}', '" . $imgPostSrc . "', '" . $imgLinkSrc . "', '{$photo['title']}', '{$linkStyle}'); return false;\" style='cursor:pointer' />";
			}
		} else if (($personMode == "my" || $personMode == "all") && !empty($searchKey)){
			$searchUser = "";
			if($personMode == "my" && !empty($nickName)){
				$person = $f->people_findByUsername($nickName);
				$searchUser = array("user_id"=>$person['id']);
			}
			$searchArray = array($searchUser,"tags"=>$searchKey, "text"=>$searchKey, "sort"=>"interestingness-desc", "per_page"=>$listLength);
//			$searchArray = array($searchUser,"text"=>$searchKey, "sort"=>"interestingness-desc", "per_page"=>$listLength);
			$photos_cat = $f->photos_search($searchArray);
			if (count((array)$photos_cat['photo']) > 0) {
				foreach ((array)$photos_cat['photo'] as $photo) {
					$imgLink = "http://www.flickr.com/photos/$photo[owner]/$photo[id]";
					$imgSrc = $f->buildPhotoURL($photo, "Square");
					$imgPostSrc = str_replace("_s.", ".", $imgSrc);
					$imgLinkSrc = ($linkStyle == "lightbox")? $f->buildPhotoURL($photo, "original") : "";
					echo "<img src='" . $imgSrc . "' border='0' alt='{$photo['title']}' title='{$photo['title']}' onclick=\"insertPhoto('{$imgLink}', '" . $imgPostSrc . "', '" . $imgLinkSrc . "', '{$photo['title']}', '{$linkStyle}'); return false;\" style='cursor:pointer' />";
				}	
			} else {
				echo "<p style='margin-top:30px; text-align:center; font-size:9pt;'>Flickr did not find any photos.</p>";		
			}
		} else if ($personMode == "all" && empty($searchKey)){
			$photos_cat = $f->photos_getRecent(NULL,$listLength ,NULL);

			foreach ((array)$photos_cat['photo'] as $photo) {
				$imgLink = "http://www.flickr.com/photos/$photo[owner]/$photo[id]";
				$imgSrc = $f->buildPhotoURL($photo, "Square");
				$imgPostSrc = str_replace("_s.", ".", $imgSrc);
				$imgLinkSrc = ($linkStyle == "lightbox")? $f->buildPhotoURL($photo, "original") : "";
				echo "<img src='" . $imgSrc . "' border='0' alt='{$photo['title']}' title='{$photo['title']}' onclick=\"insertPhoto('{$imgLink}', '" . $imgPostSrc . "', '" . $imgLinkSrc . "', '{$photo['title']}', '{$linkStyle}'); return false;\" style='cursor:pointer' />";
			}		
		} else {
			echo "<p style='margin-top:30px; text-align:center; font-size:9pt;'>Flickr did not find any photos." . (!$nickName ? "(Input nickname)" : "") . "</p>";
		}
		?>
		</div>
		</body>
		</html>
		<?php
	}
}

function getFlickrPhotosDataSet($DATA){
	requireComponent('Textcube.Function.misc');
	$cfg = misc::fetchConfigVal($DATA);
	if(!$cfg['nickname'] || empty($cfg['nickname'])) return "::Input error::\n\n Flickr's my nickname must input certainly.  ";
	return true;
}
?>